<?php
if (empty($event)) {
    throw new ApiNotFoundException(__d('api', 'Event not found'));
}
else {
    $eventHelper = MooCore::getInstance()->getHelper('Event_Event');
    $photoSizes = explode('|', Configure::read('core.photo_image_sizes'));
    $imageArray = array();
        foreach ($photoSizes as $size) {
            $imageArray[$size] = $eventHelper->getImage($event, array('prefix' => $size));
        }

        //new hook
        $response_result    = array();
        $event_systerm      = new CakeEvent('Api.view.apiEvent.json.moreEventInfo', $this, array('event' => $event));
        $this->getEventManager()->dispatch($event_systerm);

        $response_result    = !empty($event_systerm->result) ? $event_systerm->result : array();
        //end new hook

        $eventArray = array(
            'id' => $event['Event']['id'],
            'title' => h($event['Event']['title']),
            'type' => $event['Event']['moo_type'],
            'thumbnail' => $imageArray,
            'description' => $event['Event']['description'],
            'eventDate' => $event['Event']['from'],
            'privacy' => $event['Event']['type'],
            'totalAttending' => $event['Event']['event_rsvp_count'],
            'fromDate' => $event['Event']['from'],
            'fromTime' => $this->Time->event_format($event['Event']['from'], '%B %d, %Y') . " " . $event['Event']['from_time'],
            'fromTimeFormat' => $this->Time->event_format($event['Event']['from'], '%b %d'),
            'toTime' => $this->Time->event_format($event['Event']['to'], '%B %d, %Y') .  " " . $event['Event']['to_time'],
            'toTimeFormat' => $this->Time->event_format($event['Event']['to'], '%b %d'),
            'toDate' => $event['Event']['to'],
            'location' => h($event['Event']['location']),
            'address' => h($event['Event']['address']),
            'categoryId' => $event['Category']['id'],
            'categoryName' => $event['Category']['name'],
            'createName' => $event['User']['name'],
            'createId' => $event['User']['id'],
            'url' => FULL_BASE_URL .  str_replace('?','',mb_convert_encoding($event['Event']['moo_href'], 'UTF-8', 'UTF-8')),
            'shareAction' => "event_item_detail"
        );
        //new hook
        if(!empty($response_result)){
            $eventArray = array_merge($eventArray, $response_result);
        }
        
        //end new hook
    echo json_encode($eventArray);
}