import React from 'react';
import {Card, CardActions, CardHeader} from 'material-ui/Card';
import IconMenu from 'material-ui/IconMenu';
//import MenuItem from 'material-ui/MenuItem';
//import IconButton from 'material-ui/IconButton';
import Avatar from 'material-ui/Avatar';
import ActionThumbUp from 'material-ui/svg-icons/action/thumb-up';
import ActionThumbDown from 'material-ui/svg-icons/action/thumb-down';
import ActionLock from 'material-ui/svg-icons/action/lock';
import SocialPublic from 'material-ui/svg-icons/social/public';
import SocialPeople from 'material-ui/svg-icons/social/people';
import NavigationMoreVert from 'material-ui/svg-icons/navigation/more-vert';
import ActionOfflinePin from 'material-ui/svg-icons/action/offline-pin';
import _ from 'lodash';
import ActivityContent from './ItemContent';
import {ACFeedActionContent} from './ACFeedActionContent';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme from 'material-ui/styles/getMuiTheme';
import {pharse} from '../../utility/mooApp';

import ActivityActions from '../../data/actions/ActivityActions';
import ActivityViewActions from '../../data/actions/ActivityViewActions';
import CommentActions from '../../data/actions/CommentActions';

import IconButton from '@material-ui/core/IconButton';
import Menu from '@material-ui/core/Menu';
import MenuItem from '@material-ui/core/MenuItem';
import MoreVertIcon from '@material-ui/icons/MoreVert';
import Button from '@material-ui/core/Button';
import ACSticker from './plugin/ACSticker';

const iconNotActive = getMuiTheme({
    svgIcon: {
        color: "#90949c"
    }
});


export default class ActivityItemView extends React.Component {
    constructor(props) {
        super(props);

        // This binding is necessary to make `this` work in the callback
        this.handleClick = this.handleClick.bind(this);
        this.handleDeleteFeed = this.handleDeleteFeed.bind(this);
        this.handleCloseComment = this.handleCloseComment.bind(this);
        this.handlePinFeed = this.handlePinFeed.bind(this);
        this.handleClickMenu = this.handleClickMenu.bind(this);
        this.handleCloseMenu = this.handleCloseMenu.bind(this);
        this.state = {
            feedCommentStatus: ( _.has(this.props, 'feedCommentStatus','') && (_.get(this.props, 'feedCommentStatus') == '#open')) ? true : false ,
            anchorEl: null,
        };
    }
    handlePinFeed() {
        if(_.get(this.props, 'page','') && (_.get(this.props, 'page','') == 'groups.view'  || _.get(this.props, 'page','') == 'events.view')) {
            ActivityActions.pinNotHomeFeed(this.props.id);
        }
        else {
            ActivityActions.pinHomeFeed(this.props.id);
        }
    }
    handleClick(url) {
            window.location.href = url;
    }
    handleCloseComment() {
        var id,type;
        if( _.get(this.props, 'isActivityView') == true || (_.get(this.props, 'type') == 'add' && _.get(this.props, 'objects.type') != 'Photo_Album'  ) || _.get(this.props, 'type') == 'join' || _.get(this.props, 'type') == 'share'  || (_.get(this.props, 'type') == 'create' && _.get(this.props, 'objects.type') == 'Event_Event' ) || (_.get(this.props, 'type') == 'create' && _.get(this.props, 'objects.type') == 'Group_Group' ) ) {
            id = _.get(this.props, 'id', 0);
            type = 'Activity';
        }
        else {
            id = _.get(this.props, 'objects.id', 0);
            type = _.get(this.props, 'objects.type', '');
        }

        CommentActions.updateCommentStatus(type,id,false);
        this.setState({
                feedCommentStatus: !this.state.feedCommentStatus
            });
    }
    handleDeleteFeed(id) {
        if(_.has(this.props,'singleActivity') && _.get(this.props,'singleActivity') == true ) {
            ActivityViewActions.fetchDeleteFeed(id);
        }
        else {
            ActivityActions.fetchDeleteFeed(id);
        }        
    }
    handleClickMenu (event) {
        this.setState({ anchorEl: event.currentTarget });
      };

      handleCloseMenu () {
        this.setState({ anchorEl: null });
      };
    
    componentDidUpdate () {
        ACSticker.initSticker();
    }
    render() {
        //avatar={_.get(this.props, 'actor.image.50_square','')}
        var privacy,deleteFeed,feedHeader,closeComment,pinFeed,showPin ;
        showPin = pinFeed = closeComment = feedHeader = deleteFeed = <div></div>;
        var time = _.get(this.props, 'publishedTranslated','');
        switch (_.get(this.props, 'privacy','')) {
            case "1":
                privacy = <MuiThemeProvider muiTheme={iconNotActive}>
                                <IconButton style={{width: "25px", height: "30px",verticalAlign:"middle",marginLeft:"5px",padding:0}} ><SocialPublic viewBox="-5 -5 36 36" ></SocialPublic></IconButton>
                        </MuiThemeProvider>;
            break;
            case "2":
               privacy = <MuiThemeProvider muiTheme={iconNotActive}>
                                <IconButton style={{width: "25px", height: "30px",verticalAlign:"middle",marginLeft:"5px",padding:0}} ><SocialPeople viewBox="-5 -5 36 36"></SocialPeople></IconButton>
                        </MuiThemeProvider>;
            break;
            case "3":
               privacy = <MuiThemeProvider muiTheme={iconNotActive}>
                                <IconButton style={{width: "25px", height: "30px",verticalAlign:"middle",marginLeft:"5px",padding:0}} ><ActionLock viewBox="-5 -5 36 36"></ActionLock></IconButton>
                        </MuiThemeProvider>;
            break;
        }
        if(_.get(this.props, 'page','') && (_.get(this.props, 'page','') == 'groups.view'  || _.get(this.props, 'page','') == 'events.view')) {
            privacy = <div></div>;
        }
        
        if(_.has(this.props, 'canDelete','') && (_.get(this.props, 'canDelete') == true )) {
            deleteFeed = <MenuItem onClick={() => this.handleDeleteFeed(this.props.id )} >{pharse("deleteFeed")}</MenuItem>;
        }
        if(_.has(this.props, 'canClosedComment','') && (_.get(this.props, 'canClosedComment') == true )) {
            if(this.state.feedCommentStatus) {
                closeComment = <MenuItem onClick={() => this.handleCloseComment()} >{pharse("openComment")}</MenuItem>;
            }
            else {
                closeComment = <MenuItem onClick={() => this.handleCloseComment()}>{pharse("closeComment")}</MenuItem>;
            }
        }
        
        if(_.has(this.props, 'canPin','') && (_.get(this.props, 'canPin') == true )) {
            pinFeed = <MenuItem onClick={() => this.handlePinFeed()}  >{_.get(this.props, 'textPin')}</MenuItem>;
        }
        
        if(_.has(this.props, 'showPin','') && (_.get(this.props, 'showPin') == true )) {
            showPin = <ActionOfflinePin color="#90949c" ></ActionOfflinePin>;
        }
        
        
        const { anchorEl } = this.state;
            
        var menuItem = <div>
            <Button
              aria-owns={anchorEl ? 'simple-menu' : undefined}
              aria-haspopup="true"
              onClick={this.handleClickMenu}
              style={{display:"block",position:"absolute",right:"5px",top:"8px",minWidth:"0",padding:"0",minHeight:"30px"}}
            >
              <MoreVertIcon />
            </Button>
            <Menu
              id="simple-menu"
              anchorEl={anchorEl}
              open={Boolean(anchorEl)}
              onClose={this.handleCloseMenu}
            >
              {deleteFeed}
              {closeComment}
              {pinFeed}
              <MenuItem onClick={() => this.handleClick(mooConfig.url.base + '/reports/ajax_create/activity/' + this.props.id )}  >{pharse("report")}</MenuItem>
            </Menu>
        </div>
        
       
        var timePrivacy =  <div>{time}{privacy}</div> ;
        if(_.get(this.props, 'hideFeedHeader') == false) {
            feedHeader = <div> 
            <CardHeader
                style={{padding:"8px"}}
                title={<div   dangerouslySetInnerHTML={{__html: _.unescape(_.get(this.props, 'titleHtml',''))}}></div>}
                subtitle={timePrivacy}
                avatar={<Avatar style={{borderRadius: 0}} onClick={() => this.handleClick(_.get(this.props, 'actor.url',''))} src={_.get(this.props, 'actor.image.50_square','')} size={40} style={{borderRadius: 0,float:'left',display:'block'}} />}
                textStyle={{display:'block',overflow:'hidden',paddingRight:'50px'}}
            />
            
            {menuItem}
            <div style={{display: "block",position: "absolute",right: "30px",top: "8px"}} >{showPin}</div>
            </div>;
            
        
            
        }
        
        return <Card style={{position:"relative",boxShadow:"none"}} id={'activity-'+this.props.id}>
            {feedHeader}
            <ActivityContent {...this.props}/>
            <ACFeedActionContent {...this.props} />
        </Card>;
    }
}