import React from 'react';
import {Card, CardActions, CardHeader, CardMedia, CardTitle, CardText} from 'material-ui/Card';
import _ from 'lodash';
import GoogleMap from 'google-map-react';
import {Map, TileLayer, Marker, Popup, ZoomControl} from 'react-leaflet';
import {ACGridPhoto} from '../ACPost';


export  class ACCheckinLocation extends React.Component {
    
   
    constructor(props) {
        super(props);
    }
    
    renderMarkers(map, maps) {
        var myLatLng = {lat: parseFloat(_.get(this.props, 'objects.mapObject.lat','')) , lng: parseFloat(_.get(this.props, 'objects.mapObject.lng',''))};
        
        var contentString = '<div id="content">'+
            '<div id="siteNotice">'+
            '</div>'+
            '<p id="firstHeading" class="firstHeading"><b>'+ _.get(this.props, 'objects.mapObject.name','') +'</b></p>'+
            '<div id="bodyContent">'+
            _.get(this.props, 'objects.mapObject.address','')
            '</div>'+
            '</div>';

        var infowindow = new maps.InfoWindow({
          content: contentString
        });
        
        let marker = new maps.Marker({
          position: myLatLng,
          map,
          title: _.get(this.props, 'objects.mapObject.name','')
        });
        
        marker.addListener('click', function() {
          infowindow.open(map, marker);
        });
        
      }
    
    render() {
        var content,images , media,map;
        map = content = media = <div></div> ;
        images = [];
        if(_.has(this.props,'objects.contentHtml')){
            if(!_.isEmpty(this.props.objects.contentHtml)){
                content = <CardText style={{wordBreak:"break-word",padding:"8px"}} dangerouslySetInnerHTML={{__html: _.get(this.props, 'objects.contentHtml','')}}></CardText>;
            }
        } 
        media = <ACGridPhoto {...this.props}/>;
        
        var lat = parseFloat(_.get(this.props, 'objects.mapObject.lat',''));
        var lng = parseFloat(_.get(this.props, 'objects.mapObject.lng',''));

        if (mooConfig.map_mode == 1) {
            
            // Openstreetmap
            var latlng = {lat, lng};

            map = <div className="checkin_map">
                <Map center={latlng} zoom={13} zoomControl={false} >
                    <TileLayer
                    attribution='&amp;copy <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
                    url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
                    />
                    <Marker position={latlng}>
                        <Popup>{_.get(this.props, 'objects.mapObject.name','')} <br /><br /> {_.get(this.props, 'objects.mapObject.address','') }</Popup>
                    </Marker>
                    <ZoomControl position="bottomright" />
                </Map>
            </div>;
        } else {

            // GoogleMap
            map = <div className="checkin_map" style={{marginTop:"5px",width:"100%",height:"350px"}}>
            <GoogleMap
                    bootstrapURLKeys={{ key:mooConfig.google_dev_key}}
                    defaultZoom={16}
                    defaultCenter={[lat,lng]}
                    onGoogleApiLoaded={({map, maps}) => this.renderMarkers(map, maps)}
                    yesIWantToUseGoogleMapApiInternals
                >
                </GoogleMap>
                
            </div>;
        }
        
        return <div>{content}{media}{map}</div>;

    }
}
