'use strict';
const Actions = {
    animation(item){
        var _animationLoop = 3;
        var _block = item.dataset.block;
        var _quantity = item.dataset.quantity;
        var _interval = item.dataset.interval;
        if(parseInt(_block) > 1 && (item.dataset.playing == 0 || typeof item.dataset.playing == 'undefined')){

            var interval = parseInt(_interval)
            var backgroundPos = item.style.backgroundPosition.split(" "); 
            var backgroundSize = item.style.backgroundSize.split(" ");
            var xPos = parseFloat(backgroundPos[0]),
                yPos = parseFloat(backgroundPos[1]);
            var sizeW = parseFloat(backgroundSize[0]), 
                sizeH = parseFloat(backgroundSize[1]);
            var offset = ((sizeW / parseInt(_block)) * 100).toFixed(1);
            offset = Math.ceil(offset) / 100;
            var max_quantity = parseInt(_quantity) - 1;
            var quantity = 0;
            var loop = 0;
            var stickerInterval = setInterval(function() {
                item.dataset.playing = 1
                quantity += 1;
                xPos -= offset;
                if(xPos <= -sizeW){
                    xPos = 0;
                    yPos -= offset;
                }
                if(yPos < -sizeH || quantity > max_quantity){
                    quantity = 0;
                    xPos = 0;
                    yPos = 0;
                    loop += 1;
                }
                item.style.backgroundPosition = xPos + 'px ' + yPos + 'px';
                if(loop >= _animationLoop){
                    clearInterval(stickerInterval);
                    item.dataset.playing = 0;
                }
            }, interval);
        }
    },
    
    initSticker(){
        var here = this;
        var items = document.getElementsByClassName("sticker_animation");
        for(var i = 0; i < items.length; i++){
            var item = items[i];
            here.animation(item);
        }
        
        document.body.ontouchstart = function (ev) {
            if (ev.target.getAttribute("class") == "sticker_animation") {
                here.animation(ev.target);
            }
        };
    }
}
export default Actions;